=== debian/changelog ===
octave-ltfat (2.6.0+dfsg-7) unstable; urgency=medium

  * Team upload

  [ Rafael Laboissière ]
  * d/control: Bump Standards-Version to 4.7.2 (no changes needed)
  * d/control: Drop “Rules-Requires-Root: no”, which is now the default

  [ Sébastien Villemot ]
  * no-cxx11.patch: new patch, fixes FTBFS against Octave 10 (Closes: #1114617)

 -- Sébastien Villemot <sebastien@debian.org>  Sat, 20 Sep 2025 21:36:27 +0200

octave-ltfat (2.6.0+dfsg-6) unstable; urgency=medium

  * Print all output from unit tests
  * Exercice all unit tests

 -- Rafael Laboissière <rafael@debian.org>  Mon, 06 Nov 2023 15:52:20 -0300

octave-ltfat (2.6.0+dfsg-5) unstable; urgency=medium

  * d/check.m: Drop unit test test_nsdgt

 -- Rafael Laboissière <rafael@debian.org>  Sun, 05 Nov 2023 15:20:13 -0300

octave-ltfat (2.6.0+dfsg-4) unstable; urgency=medium

  * d/check.m: Drop unit test test_pconv

 -- Rafael Laboissière <rafael@debian.org>  Sun, 05 Nov 2023 05:08:48 -0300

octave-ltfat (2.6.0+dfsg-3) unstable; urgency=medium

  * d/p/test_dgt_fb_alg-function-name.patch: Add Applied-Upstream header
  * d/p/remove-cd-ltfatstart.patch: New patch
  * d/p/test-pfilt-1-function-name.patch: New patch
  * d/p/test-banners.patch: New patch
  * Add mechanism for excluding unit tests
    + d/check.m: Introduce variable LTFAT_TESTS_EXCLUDE
    + d/p/exclude-tests.patch: New patch
  * d/rules: Remove useless scripts im2double.m and normalize.m

 -- Rafael Laboissière <rafael@debian.org>  Fri, 03 Nov 2023 10:45:41 -0300

octave-ltfat (2.6.0+dfsg-2) unstable; urgency=medium

  * d/p/test_dgt_fb_alg-function-name.patch: New patch
  * d/check.m: Set seed for random numbers generator.
    This is an attempt to make the package build reproducible and, hence
    to fix Bug#1054178.

 -- Rafael Laboissière <rafael@debian.org>  Fri, 20 Oct 2023 10:25:14 -0300

octave-ltfat (2.6.0+dfsg-1) unstable; urgency=medium

  * New upstream version 2.6.0+dfsg
  * d/copyright:
    + Reflect upstream changes
    + Update Source URL
  * d/p/default-java18.patch: Drop patch (applied upstream)
  * d/p/jar-path.patch: New patch
  * d/rules: Remove the extraneously installed README.md files
  * Run all tests without restriction
    + d/p/global-unit-tests-list.patch: Drop patch (no need anymore for
      the global variable LTFAT_TESTS_TODO).
    + d/check.m: Run all tests, without exclusions

 -- Rafael Laboissière <rafael@debian.org>  Sun, 17 Sep 2023 08:34:33 -0300
