=== debian/control ===
Source: octave-ltfat
Section: math
Priority: optional
Maintainer: Debian Octave Group <team+pkg-octave-team@tracker.debian.org>
Uploaders: Rafael Laboissière <rafael@debian.org>
Build-Depends: default-jdk (>= 2:1.8~),
               debhelper-compat (= 13),
               dh-sequence-octave,
               octave (>> 4.0.0~rc4-1)
Standards-Version: 4.7.2
Homepage: https://ltfat.org/
Vcs-Git: https://salsa.debian.org/pkg-octave-team/octave-ltfat.git
Vcs-Browser: https://salsa.debian.org/pkg-octave-team/octave-ltfat
Testsuite: autopkgtest-pkg-octave

Package: octave-ltfat-common
Architecture: all
Depends: ${misc:Depends}, ${octave:Depends}
Description: Large Time/Frequency Analysis Toolbox (arch-indep files)
 This package provides a Matlab/Octave toolbox for working with
 time-frequency analysis, wavelets and signal processing. It is
 intended both as an educational and a computational tool. The toolbox
 provides a large number of linear transforms including Gabor and
 wavelet transforms along with routines for constructing windows
 (filter prototypes) and routines for manipulating coefficients.
 .
 This Octave add-on package is part of the Octave-Forge project.
 .
 This package contains the architecture-independent files for the
 octave-ltfat package.

Package: octave-ltfat
Architecture: any
Depends: ${misc:Depends}, ${octave:Depends}, ${shlibs:Depends},
 octave-ltfat-common (= ${source:Version})
Suggests: octave-signal
Description: Large Time/Frequency Analysis Toolbox
 This package provides a Matlab/Octave toolbox for working with
 time-frequency analysis, wavelets and signal processing. It is
 intended both as an educational and a computational tool. The toolbox
 provides a large number of linear transforms including Gabor and
 wavelet transforms along with routines for constructing windows
 (filter prototypes) and routines for manipulating coefficients.
 .
 This Octave add-on package is part of the Octave-Forge project.
